'==============================================================================
'
'  HELLODDT.BAS for for PowerBASIC for Windows PB/WIN 7.0
'  Copyright (c) 1997-2002 by PowerBASIC, Inc.
'
'  A simple DDT dialog example
'
'==============================================================================


'------------------------------------------------------------------------------
' Metastatements
'
#Compile Exe
'#INCLUDE "DDT.INC"
#Include "win32api.INC"
#Include "WinINet.inc"

'------------------------------------------------------------------------------
' Equates and global variables
'
%IDOK       = 1
%IDCANCEL   = 2
%IDTEXT     = 100
%IDTEXT2     = 101
%BS_DEFAULT = 1

%WS_SYSMENU = &H80000

$scUserAgent = "PB Project"

Global UserName As String

Global HyperTextBuf As String

Global hDlg   As Dword

Global Thrd_Handle As Long

Declare Function OpenURL(ByVal sUrl_Ptr As Dword) As Dword

Global hOpen As Long

Declare Function StripRange(Src As String,ByVal first As Byte,ByVal second As Byte) As String

Function STDOUT (Z As String) As Long
 ' returns TRUE (non-zero) on success
   Local hStdOut As Long, nCharsWritten As Long
   Local w As String

   hStdOut      = GetStdHandle (%STD_OUTPUT_HANDLE)
   If hSTdOut   = -1&   Then     ' invalid handle value, coded in line to avoid casting differences in Win32API.INC
     AllocConsole
     hStdOut  = GetStdHandle (%STD_OUTPUT_HANDLE)
   End If
   w = Z & $CrLf
   Function = WriteFile(hStdOut, ByVal StrPtr(W), Len(W),  nCharsWritten, ByVal %NULL)

End Function

'------------------------------------------------------------------------------
' OK button callback
'
CallBack Function OkButton()
    If CbCtlMsg = %BN_CLICKED Then
       Dim CheckThread As Long
       Thread Status Thrd_Handle To CheckThread
       If CheckThread = &H103 Then
        Dim Thread_ExitCode As Long
        GetExitCodeThread Thrd_Handle, Thread_ExitCode
        TerminateThread Thrd_Handle, Thread_ExitCode
        Dim Thc_Result As Long
        Thread Close Thrd_Handle To Thc_Result
        If Thc_Result=0 Then STDOUT FuncName$ & "|" & Time$ &"|THREAD NOT TERMINATED !!!"
       End If
       If IsTrue(hOpen) Then InternetCloseHandle hOpen

        Thread Create OpenURL(0) To Thrd_Handle
        Function = 1
    End If
End Function


'------------------------------------------------------------------------------
' Cancel button callback
'
CallBack Function CancelButton()
    If CbCtlMsg = %BN_CLICKED Then
        Dialog End CbHndl, 0
        Function = 1
    End If
End Function


'------------------------------------------------------------------------------
' Main application entry point...
'
Function PbMain() As Long
    'LOCAL hDlg   AS DWORD
    Local Result As Long

    ' ** Create a new dialog template
    Dialog New 0, "Type URL and press button",,, 200, 150,%WS_SYSMENU To hDlg

    ' ** Add controls to it
    Control Add TextBox, hDlg, %IDTEXT, "http://basicproduction.nm.ru/index.dhtml", 5,  2, 145, 12
    Control Add Button, hDlg, %IDOK, "OK", 150, 2, 40, 14, _
        %BS_DEFAULT Or %WS_TABSTOP Call OkButton

    Control Add TextBox, hDlg, %IDTEXT2, "", 5,  15, 185, 115

    ' ** Display the dialog
    Dialog Show Modal hDlg To Result

    ' ** Check the Result
    If Result Then
        MsgBox "Hello " & UserName
    End If
End Function

Function OpenURL(ByVal sUrl_Ptr As Dword) As Dword
 STDOUT "<=------------OpenURL------------=>"
Local sUrl As String
 Control Get Text hDlg, %IDTEXT To sUrl

Dim hOpenUrl As Long
Dim bDoLoop As Integer
Dim bRet As Integer
'Dim sReadBuffer As asciiz * 2048
Local sReadBuffer As String * 65536
Dim lNumberOfBytesRead As Long
Dim sBuffer As String
hOpen = InternetOpen($scUserAgent, %INTERNET_OPEN_TYPE_PRECONFIG, "", "", 0)
If hOpen=0 Then Exit Function
 STDOUT "<=------------InternetOpen------------=>"

Dim sUrl_Z As Asciiz*256
sUrl_Z=sUrl
hOpenUrl = InternetOpenUrl(hOpen, sUrl_Z, "", 0, %INTERNET_FLAG_RELOAD, 0)
If hOpenUrl=0 Then Exit Function
 STDOUT "<=------------InternetOpenUrl------------=>"

bDoLoop = %True

 Dim WorkStr As String
While_bDoLoop:
'While bDoLoop
 sReadBuffer = ""
 bRet = InternetReadFile(hOpenUrl, ByVal VarPtr(sReadBuffer), Len(sReadBuffer), lNumberOfBytesRead)
 sBuffer = sBuffer & Left$(sReadBuffer, lNumberOfBytesRead)
 Control Set Text hDlg,%IDTEXT2,Left$(sReadBuffer, lNumberOfBytesRead)
 STDOUT Left$(sReadBuffer, lNumberOfBytesRead)

 '!!! - ERROR THERE
 STDOUT StripRange(Left$(sReadBuffer, lNumberOfBytesRead),Asc("<"),Asc(">"))
 '!!! - ERROR THERE

 If lNumberOfBytesRead=0 Then bDoLoop = %False
'Wend
! CMP bDoLoop,0
! JNE While_bDoLoop

If hOpenUrl <> 0 Then Call InternetCloseHandle (hOpenUrl)
If hOpen <> 0 Then Call InternetCloseHandle (hOpen)
'OpenURL = sBuffer
'Control Set Text hDlg,%IDTEXT2,sBuffer
End Function

Function StripRange(Src As String,ByVal first As Byte,ByVal second As Byte) As String
' Strip characters between "first" & "second" inclusive.
' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Buffer$=StripRange(Buffer$,13,58)
' ---------------------------------------------
' Src is a String Value
' first  is an ascii character number (decimal)
' second is an ascii character number (decimal)
' ---------------------------------------------

      Local Dst    As String
      Local Source As Long
      Local Dest   As Long
      Local ln As Long

      ln     = Len(Src)
      Dst    = Space$(ln)
      Source = StrPtr(Src)
      Dest   = StrPtr(Dst)

        ! cld                  ; read & write forward
        ! mov ecx, ln          ; copy length into counter
        ! mov esi, Source      ; move Source pointer into esi
        ! mov edi, Dest        ; move Dest pointer into edi

'----------------------------------------------------------------

    srBegin1:
        ! mov al, [esi]        ; 1
        ! lea esi, [esi+1]     ; 1
        ! cmp al, first        ; 2
        ! je srJmpLoc2         ; 1 or j3
        ! mov [edi], al        ; 1
        ! lea edi, [edi+1]     ; 1
    srJmpLoc1:
        ! lea ecx, [ecx-1]     ; 1
        ! test ecx, ecx        ; 1
        ! jne srBegin1         ; 1 or j3
        ! jmp srOutOf2         ; 3

    srBegin2:
        ! mov al, [esi]        ; 1
        ! lea esi, [esi+1]     ; 1
    srJmpLoc2:
        ! cmp al, second       ; 2
        ! je srJmpLoc1         ; 1 or j3
        ! lea ecx, [ecx-1]     ; 1
        ! test ecx, ecx        ; 1
        ! jne srBegin2         ; 1 or j3

    srOutOf2:

    Function = RTrim$(Dst)
End Function
